﻿// Disclaimer:
// This software is provided AS IS for educational purposes only,
// with no warranties, and confers no rights. Error checking is 
// elided for clarity. Carry out sufficient tests prior to using
// it in a productive environment.
// CASIO Europe GmbH accepts no responsibility for loss or damage
// arising from its use, including damage from virus.
//
// Please, note: This configuration information may be changed
// without any further notice.
// Casio Europe GmbH does not guarantee future compatibility. By 
// using this software you agree to these terms and conditions.
//
// Version 1.00 - February 27, 2012
// Supported Devices: DT-X30, IT-800, IT-9000
//
//////////////////////////////////////////////////////////////////////

using System;

using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace CameraSample
{
    public sealed class NativeMethods
    {
        public const int WM_SETTINGCHANGE = 0x001a;
        public const int SETTINGCHANGE_RESET = 0x3002;
        public const int WM_HOTKEY = 0x0312;
        public const int PM_REMOVE = 0x0001;
        public const int WM_MOUSEFIRST = 0x0200;
        public const int WM_MOUSELAST = 0x0209;

        public class MSG
        {
            private IntPtr hwnd;
            private int message;
            private IntPtr wParam;
            private IntPtr lParam;
            private int time;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            private int[] pt;

            internal MSG()
            {
                this.hwnd = IntPtr.Zero;
                this.message = default(int);
                this.wParam = IntPtr.Zero;
                this.lParam = IntPtr.Zero;
                this.time = default(int);
                this.pt = new int[2];
            }

            internal int Message
            {
                get
                {
                    return this.message;
                }
            }

            internal int Time
            {
                get
                {
                    return this.time;
                }
            }
        }

        private NativeMethods() { }

        [DllImport("coredll.dll", SetLastError = false)]
        internal static extern int RegisterHotKey(IntPtr hWnd, int id, uint fsModifiers, uint vk);

        [DllImport("coredll.dll", SetLastError = false)]
        internal static extern int UnregisterHotKey(IntPtr hWnd, int id);

        [DllImport("coredll.dll", SetLastError = false)]
        internal static extern int PeekMessage(
            MSG lpMsg,
            IntPtr hWnd,
            int wMsgFilterMin,
            int wMsgFilterMax,
            int wRemoveMsg);
    }
}
